# -*- coding: utf-8 -*-
"""
Created on Thu Jan 16 13:43:08 2020
@author: Jaroschc

General description: 
-------------------------------------------------------------------------------
Additional functions for plotting.
-------------------------------------------------------------------------------
"""

# Used for presentation of Graphs, defines the shape of the graph
def shape_legend(node, reverse=False, **kwargs):
    handels = kwargs['handles']
    labels = kwargs['labels']
    axes = kwargs['ax']
    parameter = {}

    new_labels = []
    for label in labels:
        label = label.replace('(', '')
        label = label.replace('), flow)', '')
        label = label.replace(node, '')
        label = label.replace(',', '')
        label = label.replace(' ', '')
        new_labels.append(label)
    labels = new_labels

    parameter['bbox_to_anchor'] = kwargs.get('bbox_to_anchor', (1.01, 0.5))
    parameter['loc'] = kwargs.get('loc', 'center left')
    parameter['ncol'] = kwargs.get('ncol', 1)
    plotshare = kwargs.get('plotshare', 0.9)

    if reverse:
        handels = handels.reverse()
        labels = labels.reverse()

    box = axes.get_position()
    axes.set_position([box.x0, box.y0, box.width * plotshare, box.height])

    parameter['handles'] = handels
    parameter['labels'] = labels
    axes.legend(**parameter)
    return axes

# Function sets colors for labels
def set_color_settings():
    
    colordict= {"PV" : 'yellow',
                "Wind" : 'dodgerblue',
                "Biomasse_BHKW" : 'green', 
                "b_el_shortage":'grey',
                "Netz_im" : 'lightgrey', 
                "Rückverstromung":'red',
                "Stromnachfrage_HH": 'lightcoral',
                "Stromnachfrage_GHD": 'coral',
                "Netz_ex" : 'darkgrey',
                "PtH2" : 'darkorange',
                "Wasserstoffspeicher_in":'purple',
                "Nachfrage_H2" : 'cadetblue',
                "b_hydro_shortage" : 'pink',
                "Wasserstoffspeicher" : 'grey',
                "b_hydro_excess" : 'red'}
    
    return colordict


def set_color_settings_hydro():
    
    colordict= {
                "PtH2" : 'darkorange',
                "Wasserstoffspeicher_in":'purple',
                "Nachfrage_H2" : 'cadetblue',
                "b_hydro_shortage" : 'pink',
                "Wasserstoffspeicher" : 'grey',
                "b_hydro_excess" : 'red',
                "Rückverstromung":'black'}
    
    return colordict
